diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/cron.php mdl20-mitms-integration/lib/completion/cron.php
--- mdl-cvshead/lib/completion/cron.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/cron.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,236 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Cron job for reviewing and aggregating course completion criteria
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require_once $CFG->libdir.'/completionlib.php';
+
+
+/**
+ * Update user's course completion statuses
+ *
+ * First update all criteria completions, then
+ * aggregate all criteria completions and update
+ * overall course completions
+ *
+ * @return  void
+ */
+function completion_cron() {
+
+    completion_cron_criteria();
+
+    completion_cron_completions();
+}
+
+/**
+ * Run installed criteria's data aggregation methods
+ *
+ * Loop through each installed criteria and run the
+ * cron() method if it exists
+ *
+ * @return  void
+ */
+function completion_cron_criteria() {
+
+    // Process each criteria type
+    global $CFG, $COMPLETION_CRITERIA_TYPES;
+
+    foreach ($COMPLETION_CRITERIA_TYPES as $type) {
+
+        $object = 'completion_criteria_'.$type;
+        require_once $CFG->libdir.'/completion/'.$object.'.php';
+
+        $class = new $object();
+
+        // Run the criteria type's cron method, if it has one
+        if (method_exists($class, 'cron')) {
+
+            if (debugging()) {
+                mtrace('Running '.$object.'->cron()');
+            }
+            $class->cron();
+        }
+    }
+}
+
+/**
+ * Aggregate each user's criteria completions
+ *
+ * @return  void
+ */
+function completion_cron_completions() {
+    global $DB;
+
+    if (debugging()) {
+        mtrace('Aggregating completions');
+    }
+
+    // Grab all criteria and their associated criteria completions
+    $sql = '
+        SELECT DISTINCT
+            c.id AS course,
+            cr.id AS criteriaid,
+            ra.userid AS userid,
+            cr.criteriatype AS criteriatype,
+            cc.timecompleted AS timecompleted
+        FROM
+            {course_completion_criteria} cr
+        INNER JOIN
+            {course} c
+         ON cr.course = c.id
+        INNER JOIN
+            {context} con
+         ON con.instanceid = c.id
+        INNER JOIN
+            {role_assignments} ra
+         ON ra.contextid = con.id
+        LEFT JOIN
+            {course_completion_crit_compl} cc
+         ON cc.criteriaid = cr.id
+        AND cc.userid = ra.userid
+        LEFT JOIN
+            {course_completions} crc
+         ON crc.course = c.id
+        AND crc.userid = ra.userid
+        WHERE
+            con.contextlevel = '.CONTEXT_COURSE.'
+        AND c.enablecompletion = 1
+        AND crc.id IS NULL
+        ORDER BY
+            course,
+            userid
+    ';
+
+    // Check if result is empty
+    if (!$rs = $DB->get_recordset_sql($sql)) {
+        return;
+    }
+
+    $current_user = null;
+    $current_course = null;
+    $completions = array();
+
+    while (1) {
+
+        // Grab records for current user/course
+        foreach ($rs as $record) {
+            // If we are still grabbing the same users completions
+            if ($record->userid === $current_user && $record->course === $current_course) {
+                $completions[$record->criteriaid] = $record;
+            } else {
+                break;
+            }
+        }
+
+        // Aggregate
+        if (!empty($completions)) {
+
+            if (debugging()) {
+                mtrace('Aggregating completions for user '.$current_user.' in course '.$current_course);
+            }
+
+            // Get course info object
+            $info = new completion_info((object)array('id' => $current_course));
+
+            // Setup aggregation
+            $overall = $info->get_aggregation_method();
+            $activity = $info->get_aggregation_method(COMPLETION_CRITERIA_TYPE_ACTIVITY);
+            $role = $info->get_aggregation_method(COMPLETION_CRITERIA_TYPE_ROLE);
+
+            $overall_status = null;
+            $activity_status = null;
+            $role_status = null;
+
+            // Check each of the criteria
+            foreach ($completions as $params) {
+                $completion = new completion_criteria_completion($params, false);
+
+                // Handle aggregation special cases
+                if ($params->criteriatype == COMPLETION_CRITERIA_TYPE_ACTIVITY) {
+                    completion_cron_aggregate($activity, $completion->is_complete(), $activity_status);
+                } else if ($params->criteriatype == COMPLETION_CRITERIA_TYPE_ROLE) {
+                    completion_cron_aggregate($role, $completion->is_complete(), $role_status);
+                } else {
+                    completion_cron_aggregate($overall, $completion->is_complete(), $overall_status);
+                }
+            }
+
+            // Include role criteria aggregation in overall aggregation
+            if ($role_status !== null) {
+                completion_cron_aggregate($overall, $role_status, $overall_status);
+            }
+
+            // Include activity criteria aggregation in overall aggregation
+            if ($activity_status !== null) {
+                completion_cron_aggregate($overall, $activity_status, $overall_status);
+            }
+
+            // If aggregation status is true, mark course complete for user
+            if ($overall_status) {
+                if (debugging()) {
+                    mtrace('Marking complete');
+                }
+
+                $ccompletion = new completion_completion(array('course' => $params->course, 'userid' => $params->userid));
+                $ccompletion->mark_complete();
+            }
+        }
+
+        // If this is the end of the recordset, break the loop
+        if (!$rs->valid()) {
+            $rs->close();
+            break;
+        }
+
+        // New/next user, update user details, reset completions
+        $current_user = $record->userid;
+        $current_course = $record->course;
+        $completions = array();
+        $completions[$record->criteriaid] = $record;
+    }
+}
+
+/**
+ * Aggregate criteria status's as per configured aggregation method
+ *
+ * @param int $method COMPLETION_AGGREGATION_* constant
+ * @param bool $data Criteria completion status
+ * @param bool|null $state Aggregation state
+ * @return void
+ */
+function completion_cron_aggregate($method, $data, &$state) {
+    if ($method == COMPLETION_AGGREGATION_ALL) {
+        if ($data && $state !== false) {
+            $state = true;
+        } else {
+            $state = false;
+        }
+    } elseif ($method == COMPLETION_AGGREGATION_ANY) {
+        if ($data) {
+            $state = true;
+        } else if (!$data && $state === null) {
+            $state = false;
+        }
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completionlib.php mdl20-mitms-integration/lib/completionlib.php
--- mdl-cvshead/lib/completionlib.php	2009-08-25 11:49:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completionlib.php	2009-08-25 16:20:29.000000000 +1200
@@ -15,6 +15,12 @@
 // You should have received a copy of the GNU General Public License
 // along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
 
+require_once $CFG->libdir.'/completion/completion_aggregation.php';
+require_once $CFG->libdir.'/completion/completion_criteria.php';
+require_once $CFG->libdir.'/completion/completion_completion.php';
+require_once $CFG->libdir.'/completion/completion_criteria_completion.php';
+
+
 /**
  * Contains a class used for tracking whether activities have been completed
  * by students ('completion')
@@ -81,7 +87,7 @@
 define('COMPLETION_CACHE_EXPIRY', 10*60);
 
 // Combining completion condition. This is also the value you should return
-// if you don't have any applicable conditions.
+// if you don't have any applicable conditions. Used for activity completion.
 /** Completion details should be ORed together and you should return false if
  none apply */
 define('COMPLETION_OR', false);
@@ -89,6 +95,11 @@
  none apply */
 define('COMPLETION_AND', true);
 
+// Course completion criteria aggregation methods
+define('COMPLETION_AGGREGATION_ALL',        1);
+define('COMPLETION_AGGREGATION_ANY',        2);
+
+
 /**
  * Class represents completion information for a course.
  *
@@ -99,16 +110,48 @@
  * @package moodlecore
  */
 class completion_info {
-    /** @var object Passed during construction */
+    /** 
+     * Course object passed during construction
+     * @access  private
+     * @var     object
+     */
     private $course;
 
     /**
+     * Course id
+     * @access  public
+     * @var     int
+     */
+    public $course_id;
+
+    /**
+     * Completion criteria
+     * @access  private
+     * @var     array
+     * @see     completion_info->get_criteria()
+     */
+    private $criteria;
+
+    /**
+     * Return array of aggregation methods
+     * @access  public
+     * @return  array
+     */
+    public static function get_aggregation_methods() {
+        return array(
+            COMPLETION_AGGREGATION_ALL       => get_string('all'),
+            COMPLETION_AGGREGATION_ANY       => get_string('any', 'completion'),
+        );
+    }
+
+    /**
      * Constructs with course details.
      *
      * @param object $course Moodle course object. Must have at least ->id, ->enablecompletion
      */
     public function __construct($course) {
         $this->course = $course;
+        $this->course_id = $course->id;
     }
 
     /**
@@ -173,7 +216,195 @@
             echo '</span>';
         }
     }
-    // OU specific end
+
+    /**
+     * Get a course completion for a user
+     * @access  public
+     * @param   $user_id        int     User id
+     * @param   $criteriatype   int     Specific criteria type to return
+     * @return  false|completion_criteria_completion
+     */
+    public function get_completion($user_id, $criteriatype) {
+        $completions = $this->get_completions($user_id, $criteriatype);
+
+        // Check if self completion is one of this course's criteria
+        if (empty($completions)) {
+            return false;
+        } elseif (count($completions) > 1) {
+            print_error('multipleselfcompletioncriteria', 'completion');
+        }
+
+        return $completions[0];
+    }
+
+    /**
+     * Get all course criteria's completion objects for a user
+     * @access  public
+     * @param   $user_id        int     User id
+     * @param   $criteriatype   int     optional    Specific criteria type to return
+     * @return  array
+     */
+    public function get_completions($user_id, $criteriatype = null) {
+        $criterion = $this->get_criteria($criteriatype);
+
+        $completions = array();
+
+        foreach ($criterion as $criteria) {
+            $params = array(
+                'course'        => $this->course_id,
+                'userid'        => $user_id,
+                'criteriaid'    => $criteria->id
+            );
+
+            $completion = new completion_criteria_completion($params);
+            $completion->attach_criteria($criteria);
+
+            $completions[] = $completion;
+        }
+
+        return $completions;
+    }
+
+    /**
+     * Get completion object for a user and a criteria
+     * @access  public
+     * @param   $user_id        int     User id
+     * @param   $criteria       completion_criteria     Criteria object
+     * @return  completion_criteria_completion
+     */
+    public function get_user_completion($user_id, $criteria) {
+        $params = array(
+            'criteriaid'    => $criteria->id,
+            'userid'        => $user_id
+        );
+
+        $completion = new completion_criteria_completion($params);
+        return $completion;
+    }
+
+    /**
+     * Check if course has completion criteria set
+     *
+     * @access  public
+     * @return  bool
+     */
+    public function has_criteria() {
+        $criteria = $this->get_criteria();
+
+        return (bool) count($criteria);
+    }
+
+
+    /**
+     * Get course completion criteria
+     * @access  public
+     * @param   $criteriatype   int     optional    Specific criteria type to return
+     * @return  void
+     */
+    public function get_criteria($criteriatype = null) {
+
+        // Fill cache if empty
+        if (!is_array($this->criteria)) {
+            global $DB;
+
+            $params = array(
+                'course'    => $this->course->id
+            );
+
+            // Load criteria from database
+            $records = (array)$DB->get_records('course_completion_criteria', $params);
+
+            // Build array of criteria objects
+            $this->criteria = array();
+            foreach ($records as $record) {
+                $this->criteria[$record->id] = completion_criteria::factory($record);
+            }
+        }
+
+        // If after all criteria
+        if ($criteriatype === null) {
+            return $this->criteria;
+        }
+
+        // If we are only after a specific criteria type
+        $criteria = array();
+        foreach ($this->criteria as $criterion) {
+
+            if ($criterion->criteriatype != $criteriatype) {
+                continue;
+            }
+
+            $criteria[$criterion->id] = $criterion;
+        }
+
+        return $criteria;
+    }
+
+    /**
+     * Get aggregation method
+     * @access  public
+     * @param   $criteriatype   int     optional    If none supplied, get overall aggregation method
+     * @return  int
+     */
+    public function get_aggregation_method($criteriatype = null) {
+        $params = array(
+            'course'        => $this->course_id,
+            'criteriatype'  => $criteriatype
+        );
+
+        $aggregation = new completion_aggregation($params);
+
+        if (!$aggregation->id) {
+            $aggregation->method = COMPLETION_AGGREGATION_ALL;
+        }
+
+        return $aggregation->method;
+    }
+
+    /**
+     * Get incomplete course completion criteria
+     * @access  public
+     * @return  void
+     */
+    public function get_incomplete_criteria() {
+        $incomplete = array();
+
+        foreach ($this->get_criteria() as $criteria) {
+            if (!$criteria->is_complete()) {
+                $incomplete[] = $criteria;
+            }
+        }
+
+        return $incomplete;
+    }
+
+    /**
+     * Clear old course completion criteria
+     */
+    public function clear_criteria() {
+        global $DB;
+        $DB->delete_records('course_completion_criteria', array('course' => $this->course_id));
+        $DB->delete_records('course_completion_aggr_methd', array('course' => $this->course_id));
+
+        $this->delete_course_completion_data();
+    }
+
+    /**
+     * Has the supplied user completed this course
+     * @access  public
+     * @param   $user_id    int     User's id
+     * @return  boolean
+     */
+    public function is_course_complete($user_id) {
+        $params = array(
+            'userid'    => $user_id,
+            'courseid'  => $this->course_id
+        );
+
+        $ccompletion = new completion_completion($params);
+        return $ccompletion->is_complete();
+    }
+
     /**
      * Updates (if necessary) the completion state of activity $cm for the given
      * user.
@@ -377,13 +608,12 @@
      * editing form.
      *
      * @global object
-     * @global object
      * @param object $cm Activity
      * @return int The number of users who have completion data stored for this
      *   activity, 0 if none
      */
     public function count_user_data($cm) {
-        global $CFG, $DB;
+        global $DB;
 
         return $DB->get_field_sql("
     SELECT
@@ -395,6 +625,63 @@
     }
 
     /**
+     * Determines how much course completion data exists for a course. This is used when
+     * deciding whether completion information should be 'locked' in the completion
+     * settings form and activity completion settings.
+     *
+     * @global object
+     * @param  int $user_id Optionally only get course completion data for a single user
+     * @return int The number of users who have completion data stored for this
+     *   course, 0 if none
+     */
+    public function count_course_user_data($user_id = null) {
+        global $DB;
+
+        $sql = '
+    SELECT
+        COUNT(1)
+    FROM
+        {course_completion_crit_compl}
+    WHERE
+        course = ?
+        ';
+
+        $params = array($this->course_id);
+
+        // Limit data to a single user if an ID is supplied
+        if ($user_id) {
+            $sql .= ' AND userid = ?';
+            $params[] = $user_id;
+        }
+
+        return $DB->get_field_sql($sql, $params);
+    }
+
+    /**
+     * Check if this course's completion criteria should be locked
+     *
+     * @return  boolean
+     */
+    public function is_course_locked() {
+        return (bool) $this->count_course_user_data();
+    }
+
+    /**
+     * Deletes all course completion completion data.
+     *
+     * Intended to be used when unlocking completion criteria settings.
+     *
+     * @global  object
+     * @return  void
+     */
+    public function delete_course_completion_data() {
+        global $DB;
+
+        $DB->delete_records('course_completions', array('course' => $this->course_id));
+        $DB->delete_records('course_completion_crit_compl', array('course' => $this->course_id));
+    }
+
+    /**
      * Deletes completion state related to an activity for all users.
      * 
      * Intended for use only when the activity itself is deleted.
@@ -416,6 +703,22 @@
 
             unset($SESSION->completioncache[$cm->course][$cm->id]);
         }
+
+        // Check if there is an associated course completion criteria
+        $criteria = $this->get_criteria(COMPLETION_CRITERIA_TYPE_ACTIVITY);
+        $acriteria = false;
+        foreach ($criteria as $criterion) {
+            if ($criterion->moduleinstance == $cm->id) {
+                $acriteria = $criterion;
+                break;
+            }
+        }
+
+        if ($acriteria) {
+            // Delete all criteria completions relating to this activity
+            $DB->delete_records('course_completion_crit_compl', array('course' => $this->course_id, 'criteriaid' => $acriteria->id));
+            $DB->delete_records('course_completions', array('course' => $this->course_id));
+        }
     }
 
     /**
@@ -496,7 +799,7 @@
         // Is this the current user?
         $currentuser = $userid==$USER->id;
 
-        if ($currentuser) {
+        if ($currentuser && is_object($SESSION)) {
             // Make sure cache is present and is for current user (loginas
             // changes this)
             if (!isset($SESSION->completioncache) || $SESSION->completioncacheuserid!=$USER->id) {
@@ -664,11 +967,11 @@
      * @global object
      * @global object
      * @uses CONTEXT_COURSE
-     * @param bool $sortfirstname True to sort with firstname
+     * @param bool $sortfirstname Optional True to sort with firstname
      * @param int $groupid Optionally restrict to groupid
      * @return array Array of user objects containing id, firstname, lastname (empty if none)
      */
-    function internal_get_tracked_users($sortfirstname, $groupid=0) {
+    function internal_get_tracked_users($sortfirstname = false, $groupid = 0) {
         global $CFG, $DB;
 
         if (!empty($CFG->progresstrackedroles)) {
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/data_object.php mdl20-mitms-integration/lib/data_object.php
--- mdl-cvshead/lib/data_object.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/data_object.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,309 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+//                                                                       //
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.com                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards Martin Dougiamas  http://dougiamas.com     //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+/**
+ * A data abstraction object that holds methods and attributes
+ * @abstract
+ */
+abstract class data_object {
+    public $table;
+
+    /**
+     * Array of required table fields, must start with 'id'.
+     * @var array $required_fields
+     */
+    public $required_fields = array('id');
+
+    /**
+     * Array of optional fields with default values - usually long text information that is not always needed.
+     * If you want to create an instance without optional fields use: new data_object($only_required_fields, false);
+     * @var array $optional_fields
+     */
+    public $optional_fields = array();
+
+    /**
+     * The PK.
+     * @var int $id
+     */
+    public $id;
+
+    /**
+     * Constructor. Optionally (and by default) attempts to fetch corresponding row from DB.
+     * @param array $params an array with required parameters for this data object.
+     * @param boolean $fetch Whether to fetch corresponding row from DB or not,
+     *        optional fields might not be defined if false used
+     */
+    public function __construct($params=NULL, $fetch=true) {
+        if (!empty($params) and (is_array($params) or is_object($params))) {
+            if ($fetch) {
+                if ($data = $this->fetch($params)) {
+                    self::set_properties($this, $data);
+                } else {
+                    self::set_properties($this, $this->optional_fields);//apply defaults for optional fields
+                    self::set_properties($this, $params);
+                }
+
+            } else {
+                self::set_properties($this, $params);
+            }
+
+        } else {
+            self::set_properties($this, $this->optional_fields);//apply defaults for optional fields
+        }
+    }
+
+    /**
+     * Makes sure all the optional fields are loaded.
+     * If id present (==instance exists in db) fetches data from db.
+     * Defaults are used for new instances.
+     */
+    public function load_optional_fields() {
+        global $DB;
+        foreach ($this->optional_fields as $field=>$default) {
+            if (array_key_exists($field, $this)) {
+                continue;
+            }
+            if (empty($this->id)) {
+                $this->$field = $default;
+            } else {
+                $this->$field = $DB->get_field($this->table, $field, array('id', $this->id));
+            }
+        }
+    }
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static abstract function fetch($params);
+
+    /**
+     * Finds and returns all data_object instances based on params.
+     *
+     * @param array $params associative arrays varname=>value
+     * @return array array of data_object insatnces or false if none found.
+     */
+    public static function fetch_all($params) {}
+
+    /**
+     * Factory method - uses the parameters to retrieve matching instance from the DB.
+     * @static final protected
+     * @return mixed object instance or false if not found
+     */
+    protected static function fetch_helper($table, $classname, $params) {
+        if ($instances = self::fetch_all_helper($table, $classname, $params)) {
+            if (count($instances) > 1) {
+                // we should not tolerate any errors here - problems might appear later
+                print_error('morethanonerecordinfetch','debug');
+            }
+            return reset($instances);
+        } else {
+            return false;
+        }
+    }
+
+    /**
+     * Factory method - uses the parameters to retrieve all matching instances from the DB.
+     * @static final protected
+     * @return mixed array of object instances or false if not found
+     */
+    public static function fetch_all_helper($table, $classname, $params) {
+        $instance = new $classname();
+
+        $classvars = (array)$instance;
+        $params    = (array)$params;
+
+        $wheresql = array();
+
+        foreach ($params as $var=>$value) {
+            if (!in_array($var, $instance->required_fields) and !array_key_exists($var, $instance->optional_fields)) {
+                continue;
+            }
+            if (is_null($value)) {
+                $wheresql[] = " $var IS NULL ";
+            } else {
+                $wheresql[] = " $var = ? ";
+                $params[] = $value;
+            }
+        }
+
+        if (empty($wheresql)) {
+            $wheresql = '';
+        } else {
+            $wheresql = implode("AND", $wheresql);
+        }
+
+        global $DB;
+        if ($datas = $DB->get_records_select($table, $wheresql, $params)) {
+            
+            $result = array();
+            foreach($datas as $data) {
+                $instance = new $classname();
+                self::set_properties($instance, $data);
+                $result[$instance->id] = $instance;
+            }
+            return $result;
+
+        } else {
+            
+            return false;
+        }
+    }
+
+    /**
+     * Updates this object in the Database, based on its object variables. ID must be set.
+     * @return boolean success
+     */
+    public function update() {
+        global $DB;
+
+        if (empty($this->id)) {
+            debugging('Can not update data object, no id!');
+            return false;
+        }
+
+        $data = $this->get_record_data();
+
+        $DB->update_record($this->table, $data);
+
+        $this->notify_changed(false);
+        return true;
+    }
+
+    /**
+     * Deletes this object from the database.
+     * @return boolean success
+     */
+    public function delete() {
+        global $DB;
+
+        if (empty($this->id)) {
+            debugging('Can not delete data object, no id!');
+            return false;
+        }
+
+        $data = $this->get_record_data();
+
+        if ($DB->delete_records($this->table, array('id'=>$this->id))) {
+            $this->notify_changed(true);
+            return true;
+
+        } else {
+            return false;
+        }
+    }
+
+    /**
+     * Returns object with fields and values that are defined in database
+     */
+    public function get_record_data() {
+        $data = new object();
+
+        foreach ($this as $var=>$value) {
+            if (in_array($var, $this->required_fields) or array_key_exists($var, $this->optional_fields)) {
+                if (is_object($value) or is_array($value)) {
+                    debugging("Incorrect property '$var' found when inserting data object");
+                } else {
+                    $data->$var = $value;
+                }
+            }
+        }
+        return $data;
+    }
+
+    /**
+     * Records this object in the Database, sets its id to the returned value, and returns that value.
+     * If successful this function also fetches the new object data from database and stores it
+     * in object properties.
+     * @return int PK ID if successful, false otherwise
+     */
+    public function insert() {
+        global $DB;
+
+        if (!empty($this->id)) {
+            debugging("Data object already exists!");
+            return false;
+        }
+
+        $data = $this->get_record_data();
+
+        $this->id = $DB->insert_record($this->table, $data);
+
+        // set all object properties from real db data
+        $this->update_from_db();
+
+        $this->notify_changed(false);
+        return $this->id;
+    }
+
+    /**
+     * Using this object's id field, fetches the matching record in the DB, and looks at
+     * each variable in turn. If the DB has different data, the db's data is used to update
+     * the object. This is different from the update() function, which acts on the DB record
+     * based on the object.
+     */
+    public function update_from_db() {
+        if (empty($this->id)) {
+            debugging("The object could not be used in its state to retrieve a matching record from the DB, because its id field is not set.");
+            return false;
+        }
+        global $DB;
+        if (!$params = $DB->get_record($this->table, array('id' => $this->id))) {
+            debugging("Object with this id:{$this->id} does not exist in table:{$this->table}, can not update from db!");
+            return false;
+        }
+
+        self::set_properties($this, $params);
+
+        return true;
+    }
+
+    /**
+     * Given an associated array or object, cycles through each key/variable
+     * and assigns the value to the corresponding variable in this object.
+     * @static final
+     */
+    public static function set_properties(&$instance, $params) {
+        $params = (array) $params;
+        foreach ($params as $var => $value) {
+            if (in_array($var, $instance->required_fields) or array_key_exists($var, $instance->optional_fields)) {
+                $instance->$var = $value;
+            }
+        }
+    }
+
+    /**
+     * Called immediately after the object data has been inserted, updated, or 
+     * deleted in the database. Default does nothing, can be overridden to 
+     * hook in special behaviour.
+     *
+     * @param bool $deleted
+     */
+    function notify_changed($deleted) {
+    }
+}
